SystemOrganization addCategory: #'TKSave-Apps'!
SystemOrganization addCategory: #'TKSave-Base'!
SystemOrganization addCategory: #'TKSave-Tests'!
SystemOrganization addCategory: #'TKSave-Connection'!

!String methodsFor: '*tksave' stamp: 'tk 5/15/2008 15:45'!
asDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('description',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 6/19/2008 15:30'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('persistenceDescription',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*tksave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:46'!
magritteDescriptionClass
	^#MAStringDescription! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:50'!
magritteDescriptionDefaultValue
	^''''''! !

!JdmConnection methodsFor: '*tksave' stamp: 'tk 7/18/2008 16:02'!
socket
	^socket! !

ProtoObject subclass: #SqSaveCollectionProxy
	instanceVariableNames: 'proxiedCollection proxyOwner proxiedVariable collectionMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveCollectionProxy class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 14:04'!
for: aCollection ofInstVar: anIvarName in: anObject 
	^self new
		proxyOwner: anObject;
		proxiedCollection: aCollection;
		proxiedVariable: anIvarName
		 ! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 15:41'!
doesNotUnderstand: aMessage
	"TODO: handling for fancy load strategies here"
	self proxiedCollection ifNil: [
		self proxiedCollection: (self proxyOwner loadProxiedObjectOfVariable: self proxiedVariable).	
	].
	"TODO: implement some sort of access loggin here"
	^aMessage sendTo: self proxiedCollection.! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/28/2008 18:29'!
getCollectionChanges
	| counter changes newCollectionMap |
	counter := 0.
	newCollectionMap := self sqSaveCreateCollectionMap.
	changes := Dictionary newFrom: {#added->OrderedCollection new. #deleted->OrderedCollection new. #moved->OrderedCollection new}.
	collectionMap do: [:oid |
		| oldOid |
		counter := counter + 1.
		(counter > newCollectionMap size) ifTrue: [
			(changes at: #deleted) add: (OrderedCollection with: oid with: counter) 
		] ifFalse: [
			oldOid := newCollectionMap at: counter.
			(oldOid ~= oid) ifTrue: [
				(changes at: #moved) add: (OrderedCollection with: oid with: counter) 		
			]
		]				
	].
	[counter < newCollectionMap size] whileTrue: [
		counter := counter + 1.
		(changes at: #added) add: (OrderedCollection with: (newCollectionMap at: counter) with: counter).
	].
	^changes! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 13:59'!
proxiedCollection
	^ proxiedCollection! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/28/2008 18:06'!
proxiedCollection: anObject
	| |
	proxiedCollection := anObject.
	collectionMap := self sqSaveCreateCollectionMap! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:02'!
proxiedVariable
	^ proxiedVariable! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 16:59'!
proxiedVariable: anObject
	proxiedVariable := anObject.! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 13:59'!
proxyOwner
	^ proxyOwner! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 13:59'!
proxyOwner: anObject
	proxyOwner := anObject! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/26/2008 16:45'!
sqSaveClass
	^self proxiedCollection class! !

!SqSaveCollectionProxy methodsFor: 'accessing' stamp: 'tk 8/28/2008 18:06'!
sqSaveCreateCollectionMap
	| tmpMap |
	tmpMap := OrderedCollection new.
	proxiedCollection ifNotNil: [
		proxiedCollection do: [:obj | 
			tmpMap add: (obj ifNil: [nil] ifNotNil: [obj oid])
		]
	].
	^tmpMap
	! !

!Collection methodsFor: '*tksave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

TestCase subclass: #SqSaveBaseTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:47'!
clearDatabase
	connection resetDatabase! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/4/2008 17:36'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 8/25/2008 10:47'!
setUp
	SqSaveConnectionManager getInstance setupTestConnection.
	connection := SqSaveConnectionManager getInstance getConnectionForCategory: SqSaveConnectionManager testCategory.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/31/2008 16:26'!
testGetDirectlyReferencedObjects
	| testObject testObject2 directlyReferencedObjects |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	
	testObject testInteger: 4.
	testObject testSomething: testObject2.
	
	testObject descriptionHandler createDescriptionMethods.
	
	directlyReferencedObjects := testObject directlyReferencedObjects.
	self assert: directlyReferencedObjects size == 1.
	self assert: directlyReferencedObjects first == testObject2.
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 8/5/2008 16:47'!
testGetIndirectlyReferencedObjects
	| testObject testObject2 indirectlyReferencedObjects |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	
	testObject descriptionHandler createDescriptionMethods.
	
	indirectlyReferencedObjects := testObject indirectlyReferencedObjects.
	self assert: indirectlyReferencedObjects size == 1.
	self assert: (indirectlyReferencedObjects first at: #collection) first == testObject2.
	self assert: (indirectlyReferencedObjects first at: #description) class = SqSaveCollectionDescription.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:07'!
testGetPersistedInstanceVariables
	| |
	self assert: SqSaveTestObject persistedInstVars size = 4.
	self assert: SqSaveTestObject persistedInstVars size < SqSaveTestObjectChild persistedInstVars size.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'oid') not.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testMagritteDescriptorCreationOnSave
	| testObject |
	self removeDescriptions.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: (SqSaveTestObject class includesSelector: 'testDate' asDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testInteger' asDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testString' asDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSomething' asDescriptionSelector) not.
	self assert: SqSaveTestObject descriptionTestString class = MAStringDescription.
	self assert: SqSaveTestObject descriptionTestDate class = MADateDescription.
	self assert: SqSaveTestObject descriptionTestInteger class = MANumberDescription! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/21/2008 15:05'!
testMagritteDescriptorUpdateOnSave
	| testObject |
	self removeDescriptions.
	testObject := SqSaveTestObject new.
	testObject testSomething: SqSaveTestObjectChild new.
	testObject save.
	self assert: SqSaveTestObject persistenceDescriptionTestSomething associatedClass = SqSaveTestObjectChild name asString.
	testObject testSomething: SqSaveTestObject new.
	testObject save.
	self assert: SqSaveTestObject persistenceDescriptionTestSomething associatedClass = SqSaveTestObject name asString.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testNewRecordAttribute
	| obj obj2 |
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	self assert: obj newRecord.
	obj save.
	self assert: obj newRecord not.
	obj2 := SqSaveTestObject findByTestInteger: 42.
	self assert: obj2 newRecord not! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testObjectIdAssignment
	| testObject testObject2 |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/29/2008 11:50'!
testPersistenceDescriptorCreationOnSave
	| testObject description |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqSaveTestObject new.
	testObject save.
	description := SqSaveTestObject persistenceDescriptionTestInteger.
	self assert: description class = SqSaveColumnDescription.
	self assert: description sqlType = 'SMALLINT'.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description tableName = SqSaveTestObject name asSqSaveTableName.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:19'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'. 
	testObject save.
	self assert: (SqSaveTestObject class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObjectChild class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObjectEvenDeeperChild class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObject class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not.
	
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	self assert: SqSaveTestObject tableForClassExists not.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists! !

TestCase subclass: #SqSaveBaseWrapperTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveBaseWrapperTest methodsFor: 'tests' stamp: 'tk 8/12/2008 17:39'!
testAdditionalTableColumns
	| testObject oldColumns testWrapper testDescription newColumns |
	testObject := (SqSaveTestObject new
		testString: 'test';
		testInteger: 42;
		testSomething: 'test2';
		testDate: Date today).
	SqSaveTestObject createClassDescriptionFor: testObject.
	oldColumns := testObject allClassTableColumns.
	
	testWrapper := SqSaveBaseWrapper for: testObject.
	testDescription := SqSaveColumnDescription new.	
	testWrapper addInstVarNamed: 'testObjectId' withValue: 42 andDescription: testDescription.
	
	newColumns := testWrapper allClassTableColumns.
	self assert: newColumns keys size == (oldColumns keys size + 1).
	self assert: (newColumns includesKey: 'testObjectId').
	self assert: ((newColumns at: 'testObjectId') isNil not).
	
	
	! !

!SqSaveBaseWrapperTest methodsFor: 'tests' stamp: 'tk 8/2/2008 11:51'!
testAttributeAccessing
	| testObject testWrapper |
	testObject := SqSaveTestObject new.
	testWrapper := SqSaveBaseWrapper for: testObject.
	testWrapper addInstVarNamed: 'testObjectId' withValue: 42.
	self shouldnt: [testWrapper testObjectId] raise: Error.
	self assert: testWrapper testObjectId == 42.
	self shouldnt: [testWrapper testObjectId: 21] raise: Error.
	self assert: testWrapper testObjectId == 21.
! !

!SqSaveBaseWrapperTest methodsFor: 'tests' stamp: 'tk 8/2/2008 11:24'!
testCreationIsOnlyForSqSaveBaseObjects
	| testObject testWrapper |
	self should: [SqSaveBaseWrapper for: 42] raise: Error.
	testObject := SqSaveTestObject new.
	self shouldnt: [SqSaveBaseWrapper for: testObject] raise: Error.
	testWrapper :=  SqSaveBaseWrapper for: testObject.
	self assert: testWrapper baseObject == testObject.! !

TestCase subclass: #SqSaveCollectionTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 17:47'!
clearDatabase
	connection resetDatabase! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 10:40'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveCollectionTest methodsFor: 'private' stamp: 'tk 8/25/2008 17:47'!
setUp
	SqSaveConnectionManager getInstance setupTestConnection.
	connection := SqSaveConnectionManager getInstance getConnectionForCategory: SqSaveConnectionManager testCategory.! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/26/2008 16:48'!
testCollectionAdding

	| testObject2 testObject1 testResult testObject3 testResult2 |
	self removeDescriptions.
	self clearDatabase.	
	
	testObject2 := SqSaveTestObject new
		testInteger: 42;
		yourself.

	"this should also lead to a removal of the testSomething column...."
	testObject1 := SqSaveTestObject new
		testInteger: 21;
		testSomething: (OrderedCollection with: testObject2);
		yourself.
		
	testObject1 save.
	
	testResult := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult isNil not).
	self assert: (testResult testSomething isCollection).
	self assert: ((testResult testSomething at: 1) = testObject2).
	
	testObject3 := SqSaveTestObject new
		testInteger: 42;
		yourself.
 
	testResult testSomething add: testObject3.
	testResult save.
	
	testResult2 := SqSaveTestObject findByTestInteger: 21.
	self assert: (testResult2 isNil not).
	self assert: (testResult2 testSomething isCollection).
	self assert: ((testResult2 testSomething at: 1) = testObject2).
	self shouldnt: [(testResult2 testSomething at: 2) = testObject3] raise: Error.
	
! !

!SqSaveCollectionTest methodsFor: 'tests' stamp: 'tk 8/26/2008 17:52'!
testDescriptionCreation
	| testObject testObject2 description referenceColumn ownerColumn |
	self removeDescriptions.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	
	testObject testInteger: 4.
	testObject testSomething: (OrderedCollection with: testObject2).
	
	testObject descriptionHandler createDescriptionMethods.
	
	description := nil.
	self shouldnt: [description := SqSaveTestObjectEvenDeeperChild persistenceDescriptionTestSomething] raise: Error.
	self assert: description isNil not.
	self assert: description describesCollection.
	self assert: description joinTableName = 'sq_save_test_objects_test_something'.
	referenceColumn := description referenceColumn.
	self assert: referenceColumn columnName = 'test_something_id'.
	self assert: description referenceTableName = 'sq_save_test_objects'.
	ownerColumn := description ownerColumn.
	self assert: ownerColumn columnName = 'sq_save_test_object_id'.! !

TestCase subclass: #SqSaveColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveColumnTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:38'!
testCreationCode
	| column column2 |
	column := SqSaveColumnDescription new.
	column columnName: 'testColumn'.
	column sqlType: 'INTEGER'.
	column2 := Compiler evaluate: column creationCode.
	self assert: column2 class = SqSaveColumnDescription.
	self assert: column2 sqlType = 'INTEGER'.
	self assert: column2 columnName = 'testColumn'! !

TestCase subclass: #SqSaveConnectionManagerTest
	instanceVariableNames: 'connectionManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveConnectionManagerTest methodsFor: 'running' stamp: 'tk 6/24/2008 15:37'!
setUp
	connectionManager := SqSaveConnectionManager getInstance.! !

!SqSaveConnectionManagerTest methodsFor: 'tests' stamp: 'tk 7/14/2008 15:20'!
testAddConnectionSpecification
	| connectionSpecification connection |
	connectionManager connectionSpecificationDictionary: Dictionary new.
	connectionSpecification := SqSaveConnectionSpecification 
		user: 'thomas'
		password: 'test'
		port: 3306
		database: 'squeak_test'
		hostname: 'localhost'
		driver: #SqSaveMySQLDriver.
	connectionManager 
		setupConnectionSpecification: connectionSpecification
		for: 'TKSave'.
	self assert: (connectionManager connectionSpecificationDictionary includesKey: 'TKSave').
	self assert: (connectionManager connectionSpecificationDictionary at: 'TKSave') class == SqSaveConnectionSpecification.
	connection := connectionManager getConnectionForCategory: 'TKSave'.
	self assert: connection isNil not! !

TestCase subclass: #SqSaveDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tk 7/10/2008 17:00'!
testSqlTypeRecognition
	| handler |
	handler := SqSaveDescriptionHandler for: SqSaveTestObject new.
	self assert: (handler determineSqlTypeForObject: 42) = 'SMALLINT'.
	self assert: (handler determineSqlTypeForObject: SqSaveTestObject new) = 'INTEGER'.
	self assert: (handler determineSqlTypeForObject: SqSaveColumnDescription new) isNil.
	self assert: (handler determineSqlTypeForObject: true) = 'BOOLEAN'! !

TestCase subclass: #SqSaveDictionaryExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveDictionaryExtensionTests methodsFor: 'tests' stamp: 'tk 8/15/2008 14:49'!
testValueJoin
	| dict1 dict2 result |
	dict1 := Dictionary new.
	dict1 at: #test1 put: (OrderedCollection with: 42).
	dict1 at: #test2 put: 42.
	dict1 at: #test3 put: (OrderedCollection with: 84).
	
	dict2 := Dictionary new.
	dict2 at: #test1 put: (OrderedCollection with: 21).
	dict2 at: #test2 put: 21.
	
	result := dict1 valueJoin: dict2.
	self assert: ((result at: #test1) isCollection).
	self assert: ((result at: #test1) includes: (42)).
	self assert: ((result at: #test1) includes: (21)).

	self assert: ((result at: #test2) isCollection).
	self assert: ((result at: #test2) includes: (42)).
	self assert: ((result at: #test2) includes: (21)).

	self assert: ((result at: #test3) isCollection).
	self assert: ((result at: #test3) includes: (84)).
	! !

TestCase subclass: #SqSaveInheritanceTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveInheritanceTest subclass: #SqSaveClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveClassTableInheritanceTest methodsFor: 'running' stamp: 'tk 7/21/2008 11:50'!
setUp
	| code |
	super setUp.
	code := 'persistenceInheritanceMode',String cr,String tab, '^#classTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testCascadingDelete
	| dbConnection result testObject resultDicts oid |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	oid := testObject oid.
	testObject destroy.
	
	dbConnection := SqSaveConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectChild name asSqSaveTableName , ' WHERE oid = ',oid asString.
	resultDicts := OrderedCollection new.
	[result next] whileTrue: [
		resultDicts add: result currentRowAsDictionary.
	].
	self assert: resultDicts isEmpty.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectEvenDeeperChild name asSqSaveTableName , ' WHERE oid = ',oid asString.
	resultDicts := OrderedCollection new.
	[result next] whileTrue: [
		resultDicts add: result currentRowAsDictionary.
	].
	self assert: resultDicts isEmpty! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/14/2008 16:38'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys size = 5.
	self assert: SqSaveTestObjectChild allClassTableColumns keys size = 1.
	self assert: SqSaveTestObjectEvenDeeperChild allClassTableColumns keys size = 1.! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tk 6/30/2008 16:26'!
testTableNames
	self assert: SqSaveTestObject tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObjectChild name asSqSaveTableName.
	self assert: SqSaveTestObjectEvenDeeperChild tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName.! !

!SqSaveInheritanceTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:48'!
clearDatabase
	connection resetDatabase! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 6/26/2008 18:05'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveInheritanceTest methodsFor: 'private' stamp: 'tk 8/12/2008 13:41'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveInheritanceTest methodsFor: 'running' stamp: 'tk 8/12/2008 13:44'!
setUp
	connection := SqSaveConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	self clearDatabase.
	self removeDescriptions.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/26/2008 15:45'!
testComplexCollectionStorage
	| testObject testObject2 testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject2 := SqSaveTestObject new.
	testObject testSomething: (OrderedCollection with: testObject2).
	testObject testInteger: 42.
	
	testObject save.
	
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testObject = testResult.
	self assert: testResult testSomething class = SqSaveCollectionProxy.
	self assert: testResult testSomething first = testObject2.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	result := SqSaveTestObject findByTestInteger: 42.
	self assert: result class = SqSaveTestObject.
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	result := SqSaveTestObject findByTestInteger: 21.
	self assert: result class = SqSaveTestObjectChild! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	searchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (searchResult isNil not).
	searchResult destroy.
	newSearchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (newSearchResult isNil).! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/8/2008 16:32'!
testGetPersistedInstanceVariables
	| |
	self assert: SqSaveTestObject persistedInstVars size = 4.
	self assert: SqSaveTestObjectChild persistedInstVars size = 5.
	self assert: SqSaveTestObjectEvenDeeperChild persistedInstVars size = 6.	
	self assert: SqSaveTestObject persistedInstVars size < SqSaveTestObjectChild persistedInstVars size.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'oid') not.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	searchResult0 := SqSaveTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	searchResult1 := SqSaveTestObject findByTestInteger: 5.
	searchResult2 := SqSaveTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	searchResult3 := SqSaveTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:44'!
testObjectCompleteness
	| testObject testResult |
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: 'elevenAndAHalf'.
	testObject save.
	testResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (testResult isNil not).
	self assert: (testResult testInteger =  42).
	self assert: (testResult testString = 'fortyTwo').
	self assert: (testResult testDate = Date today).
	self assert: (testResult testSomething = 3).
	self assert: (testResult testSubString = 'twentyOne').
	self assert: (testResult testExtremelyDeepSubString = 'elevenAndAHalf').

	! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 15:23'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	self assert: testObject2 newRecord.
	testObject save.
	self assert: testObject2 newRecord not.
	self assert: testObject2 oid isNil not.
	result := SqSaveTestObject findByTestInteger: 6.
	self assert: result = testObject2! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/1/2008 13:07'!
testSomething
	self assert: true.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:45'!
testUpdate
	| testObject testResult |
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 3.14;
		testSubString: 'subString';
		testExtremelyDeepSubString: 'deepSubString'.
	testObject save.
		
	testObject testString: 'newTest'.
	testObject save.
	
	testResult := SqSaveTestObject findByTestInteger: 42.
	self assert: testResult isNil not.
	self assert: (testResult testString = 'newTest').! !

SqSaveInheritanceTest subclass: #SqSaveSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveSingleTableInheritanceTest methodsFor: 'running' stamp: 'tk 7/21/2008 11:51'!
setUp
	| code |
	super setUp.
	code := 'persistenceInheritanceMode',String cr,String tab, '^#singleTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:17'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys = SqSaveTestObjectChild allClassTableColumns keys.
	self assert: SqSaveTestObject allClassTableColumns keys = SqSaveTestObjectEvenDeeperChild allClassTableColumns keys.! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 8/12/2008 13:46'!
testSaveSubclassWithSingleTableInheritance
	| testObject |
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableForClassExists not.
	testObject := SqSaveTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: SqSaveTestObjectChild tableForClassExists! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 8/26/2008 17:30'!
testTypeParameter
	| testObject1 testObject2 dbConnection result resultDict |
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := SqSaveConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObject name asSqSaveTableName , ' WHERE test_integer = 42'.
	[ result next ] whileTrue: 
		[ resultDict := result currentRowAsDictionary.
		self assert: (resultDict at: dbConnection class inheritanceTypeField) = SqSaveTestObject name asString ].
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

TestCase subclass: #SqSaveMagritteDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'running' stamp: 'tk 6/26/2008 17:53'!
setUp
	SqSaveTestObject instVarNames do: 
		[ :ivn | 
		(SqSaveTestObject class includesSelector: ivn asDescriptionSelector) ifTrue: [ SqSaveTestObject class removeSelector: ivn asDescriptionSelector ].
		(SqSaveTestObject class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ SqSaveTestObject class removeSelector: ivn asSqSaveDescriptionSelector ] ]! !

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'tests' stamp: 'tk 8/26/2008 15:59'!
testCreateDescriptionMethods
	| obj |
	self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not.
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	obj testString: 'test'.
	obj testDate: Date today.
	(SqSaveSimpleDescriptionHandler for: obj) createDescriptionMethods.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not! !

TestCase subclass: #SqSaveStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 5/15/2008 15:46'!
testAsDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/19/2008 15:34'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

TestCase subclass: #SqSaveTableStructureHandlerTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveTableStructureHandlerTest subclass: #SqSaveClassTableInheritanceStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveClassTableInheritanceStructureTest methodsFor: 'tests' stamp: 'tk 8/12/2008 17:56'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.5243;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	
	self assert: SqSaveTestObject tableForClassExists.
	self assert: SqSaveTestObjectChild tableForClassExists.
	self assert: SqSaveTestObjectEvenDeeperChild tableForClassExists.! !

SqSaveTableStructureHandlerTest subclass: #SqSaveSingleTableInheritanceStructureTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveSingleTableInheritanceStructureTest methodsFor: 'tests' stamp: 'tk 7/14/2008 16:33'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists.! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/21/2008 11:49'!
clearDatabase
	connection resetDatabase! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/8/2008 15:26'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveTableStructureHandlerTest methodsFor: 'private' stamp: 'tk 7/8/2008 15:29'!
setTestObjectInheritanceModeTo: aSymbolString
	| code |
	code := 'persistenceInheritanceMode',String cr,String tab, '^#',aSymbolString.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveTableStructureHandlerTest methodsFor: 'running' stamp: 'tk 7/30/2008 15:03'!
setUp
	connection := SqSaveConnectionManager getInstance getConnectionForCategory: 'TKSave'.! !

!SqSaveTableStructureHandlerTest methodsFor: 'tests' stamp: 'tk 8/18/2008 10:34'!
testAlteredColumnDetection
	! !

!SqSaveTableStructureHandlerTest methodsFor: 'tests' stamp: 'tk 8/14/2008 11:58'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSaveTableStructureHandler for: sampleObject) class = SqSaveSingleTableInheritanceTableStructureHandler.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSaveTableStructureHandler for: sampleObject) class = SqSaveClassTableInheritanceTableStructureHandler.! !

WAComponent subclass: #SqSaveTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Apps'!

!SqSaveTestComponent class methodsFor: 'as yet unclassified' stamp: 'tk 4/29/2008 15:44'!
canBeRoot
	^true! !

!SqSaveTestComponent methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:53'!
renderContentOn: html 
	html anchor
		callback: [ self call: SqSaveTestObject new asComponent addValidatedForm ];
		with: 'new'! !

!Object methodsFor: '*tksave' stamp: 'tk 8/26/2008 16:43'!
sqSaveClass
	^self class! !

Object subclass: #SqSaveBase
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 15:00'!
allClassTableColumns
	| |
	^(self descriptionHandler allTableColumnsForClass: self) ! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/10/2008 17:28'!
baseClass
	| |
	self superclass = SqSaveBase ifTrue: [
		^self
	] ifFalse: [
		^self superclass baseClass
	]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:06'!
columnNameForInstVar: ivarName
	^self descriptionHandler columnNameForInstVar: ivarName ofClass: self.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 17:44'!
createClassDescriptionFor: aSampleObject
	^(self descriptionHandler for: aSampleObject) createDescriptionMethods.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 15:59'!
descriptionHandler
	^ SqSaveSimpleDescriptionHandler! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 13:49'!
doesNotUnderstand: aMessage
	| selector all attributes finderMethod startWord |
	selector := aMessage selector.
	finderMethod := selector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := selector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		all ifTrue:[startWord := 'findAllBy'] ifFalse: [startWord := 'findBy'].
		attributes := self findAttributesInSelector: aMessage selector beginWith: startWord.
		attributes ifNil: [
			^super doesNotUnderstand: aMessage.
		] ifNotNil: [
			^self performSearchFor: attributes withValues: (aMessage arguments) andReturnAll: all.
		].
	] ifFalse: [
		^super doesNotUnderstand: aMessage.
	].
	
	
	! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:15'!
findAttributesInSelector: aSelector beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName at: 1 put: ((attrName first) asLowercase).
		(self allInstVarNames includes: attrName) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [
			^nil
		]
	].
	^searchedAttributes! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
performSearchFor: instVars withValues: values andReturnAll: aBool 
	| limit results argumentDictionary |
	aBool ifFalse: [ limit := 1 ].
	argumentDictionary := (SqSaveTableStructureHandler for: self new) 
		buildSearchFor: instVars
		withValues: values.
	results := self sqSaveConnection 
		performSearchForObjectsOfClass: self
		withArguments: argumentDictionary
		andLimit: limit.
	aBool 
		ifTrue: [ ^ results ]
		ifFalse: 
			[ ^ results 
				at: 1
				ifAbsent: [ nil ] ]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:08'!
persistedInstVars
	| unpersistedVariables superClass |
	unpersistedVariables := Set withAll: self unpersistedInstVars.
	superClass := self superclass.
	[superClass ~= SqSaveBase] whileTrue: [
		unpersistedVariables addAll: superClass unpersistedInstVars.
		superClass := superClass superclass.
	].
	^self allInstVarNames difference: unpersistedVariables.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 16:20'!
persistenceInheritanceMode
	^#singleTableInheritance! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
sqSaveConnection
	^ SqSaveConnectionManager getInstance getConnectionForCategory: (self category subStrings: '-') first! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
tableForClassExists
	^ self sqSaveConnection queryForTableExistance: self tableName! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:12'!
tableName
	(self descriptionHandler inheritanceModeForClass: self) = #singleTableInheritance 
		ifTrue: 
			[ self superclass = SqSaveBase 
				ifTrue: [ ^ self name asSqSaveTableName asEscapedSql ]
				ifFalse: [ ^ self superclass tableName ] ]
		ifFalse: [ ^ self name asSqSaveTableName asEscapedSql ]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 14:08'!
unpersistedInstVars
	^#('oid')! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
updateTableColumns: changedColumnDictionary 
	| connection |
	connection := self sqSaveConnection.
	"first alter the altered columns"
	(changedColumnDictionary includesKey: #altered) ifTrue: 
		[ self sqSaveConnection alterTableColumns: (changedColumnDictionary at: #altered) ]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/20/2008 14:14'!
useInstVarAccessors
	^false! !

!SqSaveBase methodsFor: 'nil' stamp: 'tk 7/15/2008 15:10'!
= anObject
	(anObject isKindOf: (self class)) ifFalse:[
		^false.
	].
	^anObject oid = self oid.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 11:58'!
allClassTableColumns
	| |
	^(self class allClassTableColumns) ! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:28'!
asSqlValueString
	^(self oid) asSqlValueString! !

!SqSaveBase methodsFor: 'nil' stamp: 'tk 8/12/2008 16:42'!
baseClass
	^self class baseClass! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 18:23'!
createRecord
	self tableStructureHandler insertObject.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:17'!
descriptionHandler
	^self class descriptionHandler for: self! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 16:08'!
destroy
	| |
	self oid ifNotNil: [
		 (SqSaveTableStructureHandler for: self) deleteObject	
	].
	! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:09'!
directlyReferencedObjects
	^self descriptionHandler directlyReferencedObjects! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
escapedValueForInstanceVariable: iVar 
	| ivarValue |
	iVar = self class sqSaveConnection class inheritanceTypeField ifTrue: [ ^ self class name asSqlValueString ].
	ivarValue := self getValueOfInstVarNamed: iVar.
	(ivarValue class inheritsFrom: SqSaveBase) ifTrue: [ ivarValue isDirty ifTrue: [ ivarValue save ] ].
	(ivarValue respondsTo: #asSqlValueString) 
		ifTrue: [ ^ ivarValue asSqlValueString ]
		ifFalse: 
			[ self error: 'unstorable instance variable of type' , ivarValue class name , '!! Implement #asSqlValueString' ]! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 11:52'!
getValueOfInstVarNamed: iVar
	| ivarValue |
	(self respondsTo: iVar asSymbol) ifTrue: [
		(self class useInstVarAccessors) ifTrue: [
			ivarValue := self perform: iVar asSymbol.	
		] ifFalse: [
			ivarValue := self instVarNamed: iVar asSymbol.
		]
	].
	^ivarValue! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:13'!
hash
	^self oid ifNil: [0] ifNotNil: [self oid]! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:34'!
indirectlyReferencedObjects
	^self descriptionHandler indirectlyReferencedObjects! !

!SqSaveBase methodsFor: 'accessing' stamp: 'tk 6/16/2008 13:35'!
isDirty
	"TODO: enhance me with some sort of check to determine whether an object needs restoring"
	^self newRecord! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:16'!
lazilyInitializedVariables
	^#()! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 16:22'!
loadProxiedObjectOfVariable: ivarName
	^self tableStructureHandler loadProxiedObjectOfVariable: ivarName! !

!SqSaveBase methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:56'!
oid
	^oid! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:57'!
oid: anInteger
	oid := anInteger.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 10:54'!
save
	" check if the table already exisits - this is for dev mode only - FACTOR OUT"
	| |
	self class createClassDescriptionFor: self.
	self class tableForClassExists ifTrue: [
		self tableStructureHandler updateTableStructure.
	] ifFalse: [ 
		self tableStructureHandler createTableStructure
	].

	"update the record if it is already present in the database, otherwhise create it"
	self newRecord 
		ifTrue: [ self createRecord ]
		ifFalse: [ self updateRecord ]! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:19'!
setInstVarNamed: ivarName withValue: anObject
	| object lazy |
	"only set instvars of ourselves and ignore those of subclasses"
	(self class allInstVarNames includes: ivarName) ifTrue: [
		lazy := (self lazilyInitializedVariables includes: ivarName).
		object := (self descriptionHandler) 
						adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy:lazy.
		(self class useInstVarAccessors) ifTrue: [
			self perform: ((ivarName,':') asSymbol) with: object.
		] ifFalse: [
			self instVarNamed: ivarName put: object.
		]
	].! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
sqSaveConnection
	^ self class sqSaveConnection! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 16:15'!
tableName
	^self class tableName! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 15:42'!
tableStructureHandler
	^SqSaveTableStructureHandler for: self! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 15:46'!
updateRecord
	self tableStructureHandler updateObject
	! !

SqSaveBase subclass: #SqSaveTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 12:03'!
acceptsLoggingOfCompilation
	^false! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: ''!
descriptionTestInteger
	^ MANumberDescription new selectorAccessor: #testInteger;
		 label: 'testInteger';
		 default: 0;
		 yourself! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: ''!
descriptionTestSomething
	^ MAToManyRelationDescription new selectorAccessor: #testSomething;
		 label: 'testSomething';
		 yourself! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: ''!
persistenceDescriptionTestInteger
	^ SqSaveColumnDescription new manuallyMaintained: false;
		 columnName: 'test_integer';
		 sqlType: 'SMALLINT';
		 objectClass: #SmallInteger;
		 tableName: 'sq_save_test_objects';
		 canBeNull: true;
		 isPrimaryKey: false;
		 yourself! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: ''!
persistenceDescriptionTestSomething
	^ SqSaveCollectionDescription new manuallyMaintained: false;
		 collectionClass: OrderedCollection;
		 joinTableName: 'sq_save_test_objects_test_something';
		 ownerColumn: (SqSaveColumnDescription new manuallyMaintained: false;
			 columnName: 'sq_save_test_object_id';
			 sqlType: 'INTEGER';
			 foreignKey: (SqSaveForeignKeyDescription new referencedColumns: (OrderedCollection new add: 'oid';
					 yourself);
				 referencedTable: 'sq_save_test_object_even_deeper_childs';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 yourself);
		 referenceColumn: (SqSaveColumnDescription new manuallyMaintained: false;
			 columnName: 'test_something_id';
			 sqlType: 'INTEGER';
			 canBeNull: false;
			 isPrimaryKey: false;
			 yourself);
		 referenceTableName: 'sq_save_test_objects';
		 includedClass: SqSaveTestObject;
		 maintainOrder: true;
		 yourself! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: ''!
persistenceInheritanceMode
	^ #classTableInheritance! !

!SqSaveTestObject class methodsFor: 'as yet unclassified' stamp: ''!
wantsChangeSetLogging
	^ false! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate
	^ testDate! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqSaveTestObject subclass: #SqSaveTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObjectChild class methodsFor: 'magritte-description' stamp: 'tk 7/7/2008 16:30'!
unpersistedInstVars
	^#('testUnstoredVariable')! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

SqSaveTestObjectChild subclass: #SqSaveTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #SqSaveBaseWrapper
	instanceVariableNames: 'baseObject additionalInstVars instVarDescriptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveBaseWrapper class methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 11:15'!
for: anSqSaveBaseObject
	"since objects of this class are ment to wrap SqSaveObjects, only those are allowed"
	(anSqSaveBaseObject class inheritsFrom: SqSaveBase) ifFalse: [self error: 'Only SqSaveObjects allowed for this wrapper'].
	^(self new
		baseObject: anSqSaveBaseObject;
		yourself)! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:13'!
addInstVarNamed: aString withValue: anObject
	self addInstVarNamed: aString withValue: anObject andDescription: nil.! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:14'!
addInstVarNamed: aString withValue: anObject andDescription: anSqSaveColumnDescription
	self additionalInstVars at: aString put: anObject.
	self instVarDescriptions at: aString put: anSqSaveColumnDescription.! !

!SqSaveBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
additionalInstVars
	^ additionalInstVars! !

!SqSaveBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
additionalInstVars: anObject
	additionalInstVars := anObject! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:22'!
allClassTableColumns
	| columns |
	columns := self baseObject allClassTableColumns.
	self instVarDescriptions associationsDo: [:assoc |
		assoc value ifNotNil: [
			columns at: assoc key ifAbsentPut: assoc value	
		]	
	].
	^columns! !

!SqSaveBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
baseObject
	^ baseObject! !

!SqSaveBaseWrapper methodsFor: 'accessing' stamp: 'tk 7/31/2008 17:43'!
baseObject: anObject
	baseObject := anObject! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:04'!
createRecord
	self baseObject oid: (self baseObject tableStructureHandler currentObject: self) insertObject! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 11:12'!
doesNotUnderstand: aMessage
	| msgSelector setter |
	msgSelector := aMessage selector.
	setter := false.
	(msgSelector endsWith: ':') ifTrue: [
		msgSelector := msgSelector allButLast.
		setter := true
	].
	(self additionalInstVars includesKey: msgSelector) ifTrue: [
		setter ifTrue: [
			self additionalInstVars at: msgSelector put: aMessage arguments first.	
		] ifFalse: [
			^self additionalInstVars at: msgSelector
		]
	] ifFalse: [
		^aMessage sendTo: self baseObject
	].
	
	! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:12'!
initialize
	super initialize.
	self additionalInstVars: Dictionary new.
	self instVarDescriptions: Dictionary new.! !

!SqSaveBaseWrapper methodsFor: 'accessing' stamp: 'tk 8/12/2008 17:38'!
instVarDescriptions
	^ instVarDescriptions! !

!SqSaveBaseWrapper methodsFor: 'accessing' stamp: 'tk 8/2/2008 16:11'!
instVarDescriptions: anObject
	instVarDescriptions := anObject! !

!SqSaveBaseWrapper methodsFor: 'as yet unclassified' stamp: 'tk 8/2/2008 16:52'!
save
	self baseObject newRecord ifTrue: [
		self createRecord.	
	] ifFalse: [
		self updateRecord.
	]! !

Object subclass: #SqSaveConnectionManager
	instanceVariableNames: 'connectionSpecificationDictionary connectionPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

SqSaveConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

SqSaveConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

!SqSaveConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:35'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqSaveConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 10:46'!
testCategory
	^'TKSave'! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary
	^ connectionSpecificationDictionary! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary: anObject
	connectionSpecificationDictionary := anObject! !

!SqSaveConnectionManager methodsFor: 'connection-access' stamp: 'tk 5/6/2008 10:31'!
getConnectionForCategory: aCategoryName
	| cSpec  |
	cSpec := self connectionSpecificationDictionary at: aCategoryName ifAbsent: nil.
	cSpec ifNotNil: [
		^self getConnectionFromQueue: aCategoryName for: cSpec.
	].
	self error: 'no connection data specified'.
	^nil
	! !

!SqSaveConnectionManager methodsFor: 'connection-access' stamp: 'tk 7/21/2008 14:16'!
getConnectionFromQueue: aCategoryName for: aConnectionSpecification
	| availableConnections |
	availableConnections := self connectionPool at: aCategoryName ifAbsent: nil.
	availableConnections ifNil: [
		self connectionPool at: aCategoryName put: {((Smalltalk at: aConnectionSpecification driverClass) 
				onHost: aConnectionSpecification hostname 
				port: aConnectionSpecification port  
				withUser: aConnectionSpecification username  
				password: aConnectionSpecification password  
				database: aConnectionSpecification database)}
	].
	^self pickConnectionFromQueue: availableConnections! !

!SqSaveConnectionManager methodsFor: 'initialization' stamp: 'tk 5/5/2008 14:37'!
initialize
	connectionSpecificationDictionary := Dictionary new.
	connectionPool := Dictionary new.! !

!SqSaveConnectionManager methodsFor: 'connection-access' stamp: 'tk 7/21/2008 14:16'!
pickConnectionFromQueue: aQueue	
	| con |
	con := aQueue first.
	con connectionIsAlive ifFalse: [
		con reconnect
	].
	^con! !

!SqSaveConnectionManager methodsFor: 'connection-access' stamp: 'tk 5/5/2008 14:42'!
setupConnectionSpecification: aConnectionSpecification for: aCategoryName
	self connectionSpecificationDictionary at: aCategoryName put: aConnectionSpecification! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 8/25/2008 10:45'!
setupTestConnection
	| conSpec |
	conSpec := SqSaveConnectionSpecification user: 'thomas' password: 'test' port: 3306 database: 'squeak_test' hostname: 'localhost' driver: #SqSaveMySQLDriver.
	self setupConnectionSpecification: conSpec for: self class testCategory. ! !

Object subclass: #SqSaveConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSaveConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqSaveConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #SqSaveDescriptionHandler
	instanceVariableNames: 'alteredColumns currentObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/30/2008 14:54'!
allTableColumnsForClass: aClass
	| variables columnDict columnDescription |
	variables := self perform: (((self inheritanceModeForClass: aClass),'TableColumnsForClass:') asSymbol) with: aClass.
	columnDict := Dictionary new.
	variables do: [:var |
		 (aClass respondsTo: var asSqSaveDescriptionSelector) ifTrue: [
			columnDescription := aClass perform: var asSqSaveDescriptionSelector.
			columnDescription describesCollection ifFalse: [
				columnDict at: var put: columnDescription.	
			]
		] ifFalse: [
			columnDict at: var put: ((SqSaveColumnDescription new) columnName: (var decamelized))
		]
	].
	^columnDict
! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:30'!
classTableInheritanceTableColumnsForClass: aClass 
	| instVars |
	instVars := Set newFrom: (aClass instVarNames difference: aClass unpersistedInstVars).
	aClass superclass = SqSaveBase ifTrue: [ instVars add: SqSaveDriver inheritanceTypeField ].
	^ instVars! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:06'!
columnNameForInstVar: ivarName ofClass: aClass
	^ivarName decamelized! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:04'!
for: aSampleObject 
	^ self new currentObject: aSampleObject! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 16:19'!
inheritanceModeForClass: aClass
	^aClass persistenceInheritanceMode! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:30'!
singleTableInheritanceTableColumnsForClass: aClass 
	| classes sClass allInstVars |
	classes := Set newFrom: aClass allSubclasses.
	classes add: aClass.
	sClass := aClass superclass.
	[ sClass = SqSaveBase ] whileFalse: 
		[ classes add: sClass.
		sClass := sClass superclass ].
	allInstVars := Set new.
	classes do: 
		[ :klass | 
		allInstVars addAll: (klass instVarNames difference: klass unpersistedInstVars) ].
	classes ifNotEmpty: [ allInstVars add: SqSaveDriver inheritanceTypeField ].
	^ allInstVars! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:11'!
useAdvancedCollections
	^true! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 15:54'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	^self subclassResponsibility! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:51'!
alteredColumns
	^ alteredColumns! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:51'!
alteredColumns: anObject
	alteredColumns := anObject! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/14/2008 17:14'!
columnDescriptionFor: ivarName
	self subclassResponsibility! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:56'!
compileMethodCode: code intoClass: aClass
	| |
	(aClass organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		aClass organization addCategory: (self descriptorMethodCategory).
	].
	aClass class compile: code classified: (self descriptorMethodCategory).
	! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:58'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass
	^''! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 17:58'!
createDescriptionMethods
	"In order to not force everybody to implement the self describing functonality, just return an empty array with changed columns here"
	^Dictionary new! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject
	^ currentObject! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:06'!
currentObject: anObject 
	currentObject := anObject! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:51'!
determineSqlTypeForObject: anObject 
	| connection sqlType classResolved currentClass |
	connection := self currentObject class sqSaveConnection.
	(anObject class inheritsFrom: SqSaveBase) 
		ifTrue: [ sqlType := connection integer ]
		ifFalse: 
			[ classResolved := false.
			currentClass := anObject class.
			[ classResolved or: [ currentClass = Object ] ] whileFalse: 
				[ (connection respondsTo: currentClass name withFirstCharacterDownshifted) 
					ifTrue: 
						[ sqlType := connection perform: currentClass name withFirstCharacterDownshifted.
						classResolved := true ]
					ifFalse: [ currentClass := currentClass superclass ] ] ].
	^ sqlType! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:09'!
directlyReferencedObjects
	^self subclassResponsibility! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
getIvarValue: ivn 
	| anObject |
	anObject := nil.
	(self currentObject class allInstVarNames includes: ivn) ifTrue: 
		[ self currentObject class useInstVarAccessors 
			ifTrue: [ anObject := self currentObject perform: ivn asSymbol ]
			ifFalse: [ anObject := self currentObject instVarNamed: ivn asSymbol ] ].
	^ anObject! !

!SqSaveDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/31/2008 16:35'!
indirectlyReferencedObjects
	^self subclassResponsibility! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:50'!
initialize
	super initialize.
	alteredColumns := Dictionary new.! !

SqSaveDescriptionHandler subclass: #SqSaveSimpleDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveSimpleDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqSaveSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:05'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean 
	| persistenceObject |
	aBoolean 
		ifTrue: [ ^ self error: 'create proxy object handling' ]
		ifFalse: 
			[ (self currentObject class respondsTo: ivarName asSqSaveDescriptionSelector asSymbol) 
				ifTrue: 
					[ persistenceObject := self currentObject class perform: ivarName asSqSaveDescriptionSelector.
					^ persistenceObject adaptObject: anObject ]
				ifFalse: [ ^ nil ] ]! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
columnDescriptionFor: ivarName 
	^ self currentObject class perform: ivarName asSqSaveDescriptionSelector! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:47'!
createCollectionDescriptionFor: ivn basedOn: aCollection inClass: aClass
	| complexCollection |
	aCollection ifNotEmpty: [
		complexCollection := true.
		"check whether we have complex, storable objects with distinct description"
		aCollection do: [ :el |
			((complexCollection) and: [el isNil not]) ifTrue: [
				complexCollection := el class inheritsFrom: SqSaveBase	
			]
		].
		complexCollection ifTrue: [
			"create a collection description, upon which a join table will be created later on"
			^self persistenceDescriptionForCollection: aCollection withLabel: ivn.
		]
		"if not store them as a serialized BLOB"
		ifFalse: [
			^self persistenceDescriptionForObject: aCollection withLabel: ivn storedInTableNamed: aClass tableName
		]
	].
	^nil! !

!SqSaveSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:23'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass storedInTableNamed: tableName
	| column sqlType |
	column := SqSaveColumnDescription new.
	sqlType := self determineSqlTypeForObject: anObject.
	column
		columnName: aLabel decamelized;
		objectClass: anObject class name asSymbol;
		tableName: tableName;
		sqlType: sqlType.
	aClass ifNotNil: [ column associatedClass: aClass ].
	^ column! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 16:00'!
createDescriptionMethods
	| anObject targetClass |
	self currentObject class persistedInstVars do: 
		[ :ivn | 
		anObject := self getIvarValue: ivn.
		targetClass := self findTargetClassForDescriptorOfIvarNamed: ivn.
		anObject ifNotNil: 
			[ (targetClass respondsTo: ivn asDescriptionSelector) ifFalse: 
				[ self 
					createDescriptorNamed: ivn asDescriptionSelector
					for: anObject
					withLabel: ivn
					inClass: targetClass ].
			(targetClass respondsTo: ivn asSqSaveDescriptionSelector) 
				ifTrue: 
					[ self 
						updatePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ]
				ifFalse: 
					[self 
						writePersistenceDescriptorFor: ivn
						basedOn: anObject
						inClass: targetClass ] ] ].
	^ self alteredColumns! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/4/2008 17:15'!
createDescriptorNamed: aSelector for: anObject withLabel: aLabel inClass: aClass
	| code |
	code := aSelector,String cr,(self descriptorCodeFor: aLabel basedOn: anObject),String cr.
	self compileMethodCode: code intoClass: aClass.
	! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:47'!
createPersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| |
	^(anObject isCollection) ifTrue: [
		self createCollectionDescriptionFor: ivn basedOn: anObject inClass: aClass
	] ifFalse: [
		self persistenceDescriptionForObject: anObject withLabel: ivn storedInTableNamed: aClass tableName
	].! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/19/2008 15:45'!
descriptionCodeFor: anObject labeled: aLabel withClass: className
	| code |
	code := String tab,'^',className asString,' new', (self indent: 2).
	code := code, 'selectorAccessor: #', aLabel, ';',(self indent: 2).
	code := code, 'label: ''', aLabel,''';',(self indent: 2).
	(anObject respondsTo: #magritteDescriptionDefaultValue) ifTrue: [
		code := code, 'default: ', anObject magritteDescriptionDefaultValue, ';', (self indent: 2). 	
	].
	code := code, 'yourself'.
	^code! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/21/2008 16:35'!
descriptorCodeFor: aLabel basedOn: anObject 
	| className code |
	className := anObject class name.
	(anObject respondsTo: #magritteDescriptionClass) 
		ifTrue: 
			[ code := self 
				descriptionCodeFor: anObject
				labeled: aLabel
				withClass: anObject magritteDescriptionClass ]
		ifFalse: 
			[ (anObject class inheritsFrom: Collection) 
				ifTrue: 
					[code := self descriptionCodeFor: anObject labeled: aLabel withClass: #MAToManyRelationDescription ]
				ifFalse: 
					[ (anObject class inheritsFrom: SqSaveBase) 
						ifTrue: 
							[ code := self 
								descriptionCodeFor: anObject
								labeled: aLabel
								withClass: #MAToOneRelationDescription ]
					]
			].
	^ code! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:53'!
descriptorMethodCategory
	^'magritte-description'! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
directlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self currentObject class persistedInstVars do: 
		[ :ivn | 
		(self currentObject class respondsTo: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ descr := self currentObject class perform: ivn asSqSaveDescriptionSelector.
			descr associatedClass ifNotNil: 
				[ ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: [ referencedObjects add: ivarValue ] ] ] ].
	^ referencedObjects! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
findTargetClassForDescriptorOfIvarNamed: ivn 
	| targetClass |
	targetClass := self currentObject class.
	[ targetClass ~= SqSaveBase ] whileTrue: 
		[ (targetClass instVarNames includes: ivn) ifTrue: [ ^ targetClass ].
		targetClass := targetClass superclass ].
	self error: 'instance variable named ' , ivn , ' could not be found in the class hierarchy of ' , self currentObject class name! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
indirectlyReferencedObjects
	| referencedObjects descr ivarValue |
	referencedObjects := OrderedCollection new.
	self currentObject class persistedInstVars do: 
		[ :ivn | 
		(self currentObject class respondsTo: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ descr := self currentObject class perform: ivn asSqSaveDescriptionSelector.
			descr describesCollection ifTrue: 
				[ ivarValue := self getIvarValue: ivn.
				ivarValue ifNotNil: 
					[ referencedObjects add: (Dictionary newFrom: { 
								(#collection -> ivarValue).
								(#description -> descr).
								(#variable -> ivn)
							 }) ] ] ] ].
	^ referencedObjects! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
persistenceDescriptionForCollection: aCollection withLabel: ivn 
	| ownerColumn collectionSample referenceColumn |
	ownerColumn := SqSaveColumnDescription new
		sqlType: self currentObject sqSaveConnection integer;
		columnName: self currentObject baseClass name decamelized , '_id';
		foreignKey: (SqSaveForeignKeyDescription new
				referencedColumns: (OrderedCollection with: self currentObject sqSaveConnection class objectIdField);
				referencedTable: self currentObject tableName;
				deleteActions: #(#CASCADE ));
		canBeNull: false.
	collectionSample := aCollection first.
	referenceColumn := SqSaveColumnDescription new
		sqlType: collectionSample sqSaveConnection integer;
		columnName: ivn decamelized , '_id';
		canBeNull: false.
	self class useAdvancedCollections ifFalse: 
		[ referenceColumn foreignKey: (SqSaveForeignKeyDescription new
				referencedColumns: (OrderedCollection with: collectionSample sqSaveConnection class objectIdField);
				referencedTable: collectionSample baseClass tableName;
				deleteActions: #(#CASCADE )) ].
	^ SqSaveCollectionDescription new
		referenceTableName: collectionSample baseClass tableName;
		referenceColumn: referenceColumn;
		collectionClass: aCollection sqSaveClass;
		maintainOrder: self class useAdvancedCollections;
		ownerColumn: ownerColumn;
		includedClass: collectionSample baseClass;
		joinTableName: self currentObject baseClass name asSqSaveTableName , '_' , ivn decamelized! !

!SqSaveSimpleDescriptionHandler methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:50'!
persistenceDescriptionForObject: anObject withLabel: aLabel storedInTableNamed: tableName 
	| linkedClass |
	linkedClass := (anObject class inheritsFrom: SqSaveBase) 
		ifTrue: [ anObject class name asSymbol ]
		ifFalse: [ nil ].
	^ self 
		createColumnDescriptionForObject: anObject
		withLabel: aLabel
		linkedTo: linkedClass
		storedInTableNamed: tableName! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 16:46'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| previousClass oldDescription |
	oldDescription := aClass perform: ivn asSqSaveDescriptionSelector.
	"for the brave ones, we leave everything as is"
	oldDescription manuallyMaintained ifFalse: [
		oldDescription describesCollection ifFalse: [
			previousClass := Smalltalk at: oldDescription objectClass asSymbol.
			"if we have a subclass of our previous class, we're fine - otherwhise, we have to alter the table and the description"
			((anObject class inheritsFrom: previousClass) or: [anObject sqSaveClass = previousClass]) ifFalse: [
				self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
				"TODO: this is the place where we should ask the user if the change is ok???"
			]
		] ifTrue: [
			self writePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass.
		]
	].	
	! !

!SqSaveSimpleDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:42'!
writePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass
	| description code |
	description := self createPersistenceDescriptorFor: ivn basedOn: anObject  inClass: targetClass.
	description ifNotNil: [
		code := ivn asSqSaveDescriptionSelector, String cr.
		code := code,'^', description creationCode.
		self compileMethodCode: code intoClass: targetClass
	].! !

Object subclass: #SqSaveDriver
	instanceVariableNames: ''
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSaveDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:31'!
collectionOrderField
	^'order_number'! !

!SqSaveDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:30'!
inheritanceTypeField
	^ 'sq_save_type_field'! !

!SqSaveDriver class methodsFor: 'as yet unclassified' stamp: 'tk 8/5/2008 17:24'!
objectIdField
	^'oid'! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:42'!
addColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAddColumn: column).	
		]
	"]"
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:47'!
alterColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToAlterColumn: column).	
		]
	"]"
	! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 7/7/2008 17:00'!
bodyForInsertOf: anObject
	| fields values |
	fields := ''.
	values := ''.
	anObject class allClassTableColumns associationsDo:[ :assoc |
		fields := fields, assoc value columnName, ', '.
		values := values, (anObject escapedValueForInstanceVariable: assoc key), ', '.
	].
	fields := fields allButLast:2.
	values := values allButLast:2.
	^'(',fields,') VALUES (',values,')'! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:19'!
commitTransaction	
	self executeQuery:(self queryForCommit). .! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'wh 8/17/2006 15:37'!
connection
	self subclassResponsibility.! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'tk 5/13/2008 15:17'!
connectionIsAlive
	self subclassResponsibility.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:33'!
createJoinTableNamed: tableName withColumns: columns
	self executeQuery: (self queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: true). ! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:33'!
createJoinTableNamed: tableName withColumns: columns andOrderField: bool
	self executeQuery: (self queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: bool). ! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'tk 6/11/2008 14:12'!
createObjectsOfClass: aClass fromResultSet: result
	^self subclassResponsibility! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:20'!
database
	self subclassResponsibility.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/12/2008 16:11'!
getCollectionDescribedBy: descr forObjectId: oid
	"Dunno how much we can keep here - maybe move this up from mysql if consistent code can be found"
	self subclassResponsibility! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:15'!
inTransactionDo: aBlock
	self inTransactionDo: aBlock onError: [self rollback].! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/30/2008 14:36'!
inTransactionDo: aBlock onError: anErrorBlock
	self startTransaction.
	[aBlock value] ifError: [:err |
		"anErrorBlock value."
		self error: err.
	].
	self commitTransaction.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
largeInteger
	^'BIGINT'.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 5/22/2008 17:04'!
lastOidFromTable: aTable
	self subclassResponsibility! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'tk 7/29/2008 11:57'!
log: aString
	"TODO: viable solution for logging - Transcript is just weigh to slow"
	Transcript show: '+++++++++++++++++++';
		show: String cr;
		show: aString;
		show: String cr.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:34'!
oid
	^self unsignedInteger, ' PRIMARY KEY '.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:30'!
oidColumn
	"I believe this is the SQL standard but I don't think any SQL databases 
		follow it "

	^'INTEGER PRIMARY KEY GENERATED ALWAYS AS IDENTITY'! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 19:51'!
performSearchForObjectsOfClass: aClass withArguments: argumentDictionary andLimit: aLimit
	| sql result results |
	sql := 'SELECT * FROM ', (argumentDictionary keys join: ' NATURAL JOIN '), ' WHERE '.
	argumentDictionary associationsDo: [:assoc |
		assoc value associationsDo: [ :joiner |
			sql := sql, '('.
			sql := sql, ((joiner value collect: [:searchAttr |
				assoc key,'.', searchAttr key, ' = ', searchAttr value asSqlValueString
			]) join: (' ',joiner key,' ')).
			sql := sql,') AND '.
		].
	].
	sql := sql allButLast: 5.
	aLimit ifNotNil: [sql := sql, ' LIMIT ', aLimit asString].
	result := self executeQuery: (sql).
	results := self createObjectsOfClass: aClass fromResultSet: result.
	^results! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/10/2006 17:05'!
queryForCommit
	^'COMMIT'.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 17:15'!
queryForForeignKeyConstraint: aForeignKeyDescription ofColumn: aColumnName
	| sql |
	sql := 'FOREIGN KEY (',aColumnName,') REFERENCES '.
	sql := sql, aForeignKeyDescription referencedTable,'(', aForeignKeyDescription referencedColumns first,') '.
	aForeignKeyDescription deleteActions ifNotEmpty: [sql := sql, 'ON DELETE'].
	aForeignKeyDescription deleteActions do: [:action | sql := sql, ' ',action].
	aForeignKeyDescription updateActions ifNotEmpty: [sql := sql, 'ON UPDATE'].
	aForeignKeyDescription updateActions do: [:action | sql := sql, ' ',action].
	^sql! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:30'!
queryForObjectsOf: aClass byAttributes: argumentDictionary inTable: aTableName withLimit: limit 
	| query result results |
	query := 'SELECT * FROM ' , aTableName , ' WHERE '.
	(aClass descriptionHandler inheritanceModeForClass: aClass) = #singleTableInheritance ifTrue: 
		[ query := query , '( ' , self class inheritanceTypeField , ' = ' , aClass name asSqlValueString.
		aClass allSubclasses do: 
			[ :subClass | 
			query := query , ' OR ' , self class inheritanceTypeField , ' = ' , subClass name asSqlValueString ].
		query := query , ') AND ' ].
	argumentDictionary associationsDo: 
		[ :pair | 
		query := query , pair key , ' = ' , pair value asSqlValueString , ' AND ' ].
	query := query allButLast: 5.
	limit ifNotNil: [ query := query , ' LIMIT ' , limit asString ].
	result := self executeQuery: query.
	results := self 
		createObjectsOfClass: aClass
		fromResultSet: result.
	^ results! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/13/2006 12:41'!
queryForStartTransaction
	^'START TRANSACTION'.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/15/2008 16:49'!
queryForTableExistance: aClassName
	| result tableExists |
	result := self executeQuery: 'SHOW TABLES'.
	tableExists := false.
	[result next] whileTrue: [
		tableExists ifFalse: [
			tableExists := (result valueNamed: (result columns first name)) = aClassName.
		]
	].
	^tableExists
! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:45'!
queryToAddColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' ADD COLUMN '.
	sql := sql, aColumn columnName, ' ', aColumn sqlType.
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:48'!
queryToAlterColumn: aColumn
	| sql |
	sql := 'ALTER TABLE ', aColumn tableName, ' MODIFY '.
	sql := sql, aColumn columnName, ' ', aColumn sqlType.
	aColumn canBeNull ifFalse: [
		sql := sql, ' NOT NULL'	
	].
	^sql! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 6/19/2008 16:56'!
queryToAlterColumns: anAssociation forTable: tableName
	| sql |
	sql := 'ALTER TABLE ',tableName, ' MODIFY '.
	sql	:= sql, (self escapedRowName: anAssociation key), ' ', anAssociation value.
	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:43'!
queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool
	| sql |
	sql := 'CREATE TABLE ', tableName, ' ('.
	"create the three (or two...) columns of the join table"
	columns do: [ :columnDescr |
		sql := sql, columnDescr columnName, ' ', columnDescr sqlType.
		columnDescr foreignKey ifNotNil: [
			sql := sql, ' NOT NULL, ', (self queryForForeignKeyConstraint: columnDescr foreignKey ofColumn: columnDescr columnName). 	
		].
		sql := sql, ', '.
	].
	aBool ifTrue: [
		sql := sql, self class collectionOrderField,' ',(self integer),' NOT NULL, '.
	].
	
	"and set up a primary key over those columns (will be always unique)"
	sql := sql, ' PRIMARY KEY (', ((columns collect: [:columnDescr | columnDescr columnName]) join: ', ').
	aBool ifTrue: [
		sql := sql, ', ',self class collectionOrderField.
	].
	sql := sql, '))'.
	^sql! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 5/22/2008 15:31'!
queryToCreateObject: anObject
	|sql|
	sql := 'INSERT INTO ', anObject tableName, ' '.
	sql := sql,(self bodyForInsertOf: anObject). 
	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:30'!
queryToCreateTableNamed: tableName withColumns: columnDict 
	| sql type primaryKeyColumns |
	sql := 'CREATE TABLE ' , tableName , ' ('.
	(columnDict includesKey: 'oid') ifFalse: [ sql := sql , '`oid` ' , self oidColumn , ',' ].
	columnDict associationsDo: 
		[ :assoc | 
		type := self smallInteger.
		assoc value sqlType 
			ifNil: 
				[ assoc key = self class inheritanceTypeField ifTrue: [ type := self string ] ]
			ifNotNil: [ type := assoc value sqlType ].
		sql := sql , (self escapedRowName: assoc value columnName) , ' ' , type.
		assoc value canBeNull ifFalse: [ sql := sql , ' NOT NULL' ].
		sql := sql , ', '.
		assoc value foreignKey ifNotNil: 
			[ sql := sql , (self 
					queryForForeignKeyConstraint: assoc value foreignKey
					ofColumn: assoc key) , ', ' ] ].
	sql := sql allButLast: 2.
	primaryKeyColumns := (columnDict values select: [ :columnDescr | columnDescr isPrimaryKey ]) collect: [ :columnDescr | columnDescr columnName ].
	primaryKeyColumns ifNotEmpty: 
		[ sql := sql , ', PRIMARY KEY (' , (primaryKeyColumns join: ', ') , ')' ].
	sql := sql , ')'.
	^ sql! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:46'!
queryToRemoveColumn: aColumn
	^'ALTER TABLE ',aColumn tableName,' DROP COLUMN ', aColumn columnName.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 4/29/2008 16:11'!
queryToRemoveTableForClass: aClass
	| sql |
	sql := 'DROP TABLE ', aClass name.
	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 8/25/2008 11:41'!
queryToRenameColumns: columnsCollection
	| oldColumn sql newColumn |
	oldColumn := columnsCollection first.
	newColumn := columnsCollection at: 2.
	sql := 'ALTER TABLE ', oldColumn tableName, ' CHANGE '.
	sql := sql, oldColumn columnName, ' ', newColumn columnName, ' ', newColumn sqlType.
	^sql 
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 15:20'!
reServeObject
	^self unsignedInteger.! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'tk 7/21/2008 14:18'!
reconnect
	self subclassResponsibility.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:45'!
removeColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:column |
			self executeQuery: (self queryToRemoveColumn: column).	
		]
	"]"
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/15/2008 16:06'!
removeObjectWithId: oid fromTable: tableName
	| sql |
	sql := 'DELETE FROM ',tableName,' WHERE oid = ',oid asString.
	self executeQuery: (sql).! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:41'!
renameColumns: columnsCollection
	"takes a collection of columns - each of which has the old and the new name"
	"self inTransactionDo: ["
		columnsCollection do: [:columnPair |
			self executeQuery: (self queryToRenameColumns: columnPair).	
		]
	"]"
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/30/2008 15:09'!
resetDatabase
	| |
	self executeQuery: 'DROP DATABASE ', self database.
	self executeQuery: 'CREATE DATABASE ', self database.
	self reconnect.
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/18/2008 16:22'!
rollback
	"self localCache do:[:object | object rollback ].
	self rollbackDbTransaction."
	"self executeQuery: 'ROLLBACK'"! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:24'!
rollbackDbTransaction
	self executeQuery:(self queryForRollback) .! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:16'!
serial
	self subclassResponsibility.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:18'!
startTransaction
	self executeQuery:(self queryForStartTransaction).! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 15:42'!
storeColumns: columnDict inTable: aTableName
	self storeColumns: columnDict inTable: aTableName  andReturnOId: false.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:07'!
storeColumns: columnDict inTable: aTableName andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	self executeQuery: (sql).
	aBool ifTrue: [
		^self lastOidFromTable: aTableName	
	].! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/16/2006 22:18'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER '.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 8/25/2008 11:14'!
updateFields: columnDict ofObjectWithId: oid inTable: aTableName 
	| sql |
	sql := 'UPDATE ' , aTableName , ' SET '.
	columnDict associationsDo: [ :assoc | sql := sql , assoc key , ' = ' , assoc value asString , ', ' ].
	sql := (sql allButLast: 2) , ' WHERE oid = ' , oid asString.
	self executeQuery: sql! !

SqSaveDriver subclass: #SqSaveMySQLDriver
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSaveMySQLDriver class methodsFor: 'as yet unclassified' stamp: 'wh 8/8/2006 23:11'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	^(self new ) 
		onHost: aHost 
		port: aPort 
		withUser: aUser 
		password: aPassword 
		database: aDatabase.! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:18'!
connection
	^connection! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'tk 7/18/2008 15:53'!
connectionIsAlive
	^self connection socket isConnected! !

!SqSaveMySQLDriver methodsFor: 'converting' stamp: 'tk 8/26/2008 17:30'!
createObjectsOfClass: aClass fromResultSet: result 
	| results object resultDicts targetClass ivarValue |
	results := OrderedCollection new.
	resultDicts := OrderedCollection new.
	"store all data rows in our own structure - this way we can issue new commands upon object creation"
	[ result next ] whileTrue: [ resultDicts add: result currentRowAsDictionary copy ].
	"load the objects for each row"
	resultDicts do: 
		[ :resultDict | 
		targetClass := resultDicts first 
			at: self class inheritanceTypeField
			ifAbsent: [ aClass name ].
		targetClass := Smalltalk 
			at: targetClass asSymbol
			ifAbsent: [ nil ].
		targetClass ifNotNil: 
			[ object := targetClass new.
			object oid: (resultDict at: self class objectIdField).
			targetClass persistedInstVars do: 
				[ :ivar | 
				"set up a proxy object, if the value is not available within the current table"
				ivarValue := resultDict 
					at: (targetClass columnNameForInstVar: ivar)
					ifAbsent: 
						[ SqSaveCollectionProxy 
							for: nil
							ofInstVar: ivar
							in: object ].
				object 
					setInstVarNamed: ivar
					withValue: ivarValue ].
			results add: object ] ].
	^ results! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:22'!
database
	^connection connectionSpec database! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:20'!
driverClass
	^JdmConnection.! !

!SqSaveMySQLDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:54'!
executeQuery: aQuery
	| |
	self log: aQuery.
	^(self connection createStatement) executeQuery:(aQuery)! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'tk 8/26/2008 17:47'!
getCollectionDescribedBy: descr forObjectId: oid
	| sql results |
	sql := 'SELECT ', descr referenceTableName, '.* '.
	sql := sql, 'FROM ', descr joinTableName, ', ', descr referenceTableName, ' '.
	sql := sql, 'WHERE ', descr joinTableName ,'.', descr ownerColumn columnName, ' = ', oid asString.
	sql := sql, ' AND ', descr joinTableName,'.', descr referenceColumn columnName.
	sql := sql, ' = ', descr referenceTableName, '.', self class objectIdField.
	results := self executeQuery: sql.
	^self createObjectsOfClass: descr includedClass fromResultSet: results. ! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/21/2008 14:55'!
lastOidFromTable: aTable
	 | oid |
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:20'!
newConnection
	^ self driverClass on: (self connection connectionSpec).! !

!SqSaveMySQLDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:21'!
oidColumn
	^'INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT '.! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:27'!
oidForNewObject: anObject
	 | oid |
	(self connection createStatement) executeQuery: (self queryForNewObjectOfClass:(anObject class)).
	"Ugh MySQL driver trickery"
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/16/2006 23:39'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	| spec |
	Socket initializeNetwork.
	spec :=    (JdmConnectionSpec new initialize
        user: aUser; password: aPassword;
        host: (NetNameResolver addressForName: aHost);
        database: aDatabase;
        port: aPort).
	connection := (self driverClass) on: spec.
	! !

!SqSaveMySQLDriver methodsFor: 'sql statements' stamp: 'tk 8/26/2008 17:35'!
queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool
	^ (super queryToCreateJoinTableNamed: tableName withColumns: columns andOrderField: aBool) , ' ENGINE=INNODB'.! !

!SqSaveMySQLDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 16:54'!
queryToCreateTableNamed: tableName withColumns: columnDict
	^ (super queryToCreateTableNamed: tableName withColumns: columnDict) , ' ENGINE=INNODB'.! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'tk 7/29/2008 11:56'!
reconnect
	self log: 'reconnecting'.
	[connection close] ifError: [:err | Transcript show: err].
	connection initialize2.! !

Object subclass: #SqSaveForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:31'!
initialize
	super initialize.
	self updateActions: #().
	self deleteActions: #().! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqSaveForeignKeyDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/22/2008 13:54'!
storeOn: aStream

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;;
				nextPutAll: (String cr, String tab, String tab)
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

Object subclass: #SqSavePersistenceDescription
	instanceVariableNames: 'associatedClass manuallyMaintained'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSavePersistenceDescription subclass: #SqSaveCollectionDescription
	instanceVariableNames: 'collectionClass joinTableName ownerColumn referenceColumn referenceTableName includedClass maintainOrder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass
	^ collectionClass! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 14:45'!
collectionClass: anObject
	collectionClass := anObject! !

!SqSaveCollectionDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/23/2008 15:13'!
describesCollection
	^true! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/12/2008 16:58'!
includedClass
	^ includedClass! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/12/2008 16:58'!
includedClass: anObject
	includedClass := anObject! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName
	^ joinTableName! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
joinTableName: anObject
	joinTableName := anObject! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder
	^ maintainOrder! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:14'!
maintainOrder: anObject 
	maintainOrder := anObject! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn
	^ ownerColumn! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
ownerColumn: anObject
	ownerColumn := anObject! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn
	^ referenceColumn! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceColumn: anObject
	referenceColumn := anObject! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName
	^ referenceTableName! !

!SqSaveCollectionDescription methodsFor: 'accessing' stamp: 'tk 8/5/2008 17:06'!
referenceTableName: anObject
	referenceTableName := anObject! !

SqSavePersistenceDescription subclass: #SqSaveColumnDescription
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull isPrimaryKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 8/26/2008 17:16'!
foreignKey: anObject
	foreignKey := anObject.
	"being a foreign key, the column can not be null"
	self canBeNull: false.! !

!SqSaveColumnDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/14/2008 13:41'!
initialize
	super initialize.
	self canBeNull: true.
	self isPrimaryKey: false.! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey
	^ isPrimaryKey! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 8/14/2008 11:56'!
isPrimaryKey: anObject
	isPrimaryKey := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

!SqSavePersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:16'!
adaptObject: anObject
	self associatedClass ifNil: [
		^anObject	
	] ifNotNil: [
		^(Smalltalk at: (self associatedClass asSymbol)) findByOid: anObject 
	]! !

!SqSavePersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqSavePersistenceDescription methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

!SqSavePersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 14:44'!
creationCode
	| aStream |
	aStream := TextStream on: String new.

	aStream nextPut: $(.
	aStream nextPutAll: self class name, ' new'.
	aStream nextPutAll: (String cr, String tab).
	1 to: self class instSize do:
		[:i |
		(self instVarAt: i) ifNotNil: [
			aStream 
				nextPutAll: (String cr, String tab);
				nextPutAll: (' ',(self class allInstVarNames at: i),': ');
				store: (self instVarAt: i);
				nextPut: $;
			]
		].
	1 to: self basicSize do:
		[:i |
		aStream nextPutAll: ' basicAt: ';
			store: i;
			nextPutAll: ' put: ';
			store: (self basicAt: i);
			nextPut: $;].
	aStream nextPutAll: ' yourself)'.
	^aStream contents
	! !

!SqSavePersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/23/2008 15:12'!
describesCollection
	^false! !

!SqSavePersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/15/2008 16:37'!
initialize
	super initialize.
	self manuallyMaintained: false.! !

!SqSavePersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained
	^ manuallyMaintained! !

!SqSavePersistenceDescription methodsFor: 'accessing' stamp: 'tk 8/15/2008 16:38'!
manuallyMaintained: anObject
	manuallyMaintained := anObject! !

!SqSavePersistenceDescription methodsFor: 'as yet unclassified' stamp: 'tk 8/5/2008 18:58'!
storeOn: aStream
	aStream nextPutAll: self creationCode! !

Object subclass: #SqSaveProxyObject
	instanceVariableNames: 'proxiedVariable targetObject actualObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveProxyObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 13:23'!
forAttribute: ivarName ofClass: aClass
	^(self new
		proxiedVariable: ivarName;
		targetClass: aClass;
		yourself)! !

!SqSaveProxyObject class methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 15:43'!
forAttribute: ivarName ofObject: aClass
	^(self new
		proxiedVariable: ivarName;
		targetObject: aClass;
		yourself)! !

!SqSaveProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
actualObject
	^ actualObject! !

!SqSaveProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
actualObject: anObject
	actualObject := anObject! !

!SqSaveProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 13:21'!
proxiedVariable
	^ proxiedVariable! !

!SqSaveProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 13:21'!
proxiedVariable: anObject
	proxiedVariable := anObject! !

!SqSaveProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
targetObject
	^ targetObject! !

!SqSaveProxyObject methodsFor: 'accessing' stamp: 'tk 8/12/2008 15:42'!
targetObject: anObject
	targetObject := anObject! !

Object subclass: #SqSaveTableStructureHandler
	instanceVariableNames: 'currentObject'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSaveTableStructureHandler subclass: #SqSaveClassTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
buildSearchFor: instVars withValues: values 
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName |
	descrHandler := self currentObject descriptionHandler.
	targetClass := self currentObject class.
	searchDict := Dictionary new.
	baseClass := targetClass baseClass.
	typeField := targetClass sqSaveConnection class inheritanceTypeField.
	instVars withIndexDo: 
		[ :ivar :index | 
		ivar = 'oid' 
			ifTrue: 
				[ tableName := baseClass tableName.
				columnName := 'oid' ]
			ifFalse: 
				[ descr := descrHandler columnDescriptionFor: ivar.
				tableName := descr tableName.
				columnName := descr columnName ].
		(searchDict 
			at: tableName
			ifAbsentPut: Dictionary new) 
			at: #AND
			ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: columnName -> (values at: index) ].
	(searchDict 
		at: baseClass tableName
		ifAbsentPut: Dictionary new) 
		at: #OR
		ifAbsentPut: Set new.
	((searchDict at: baseClass tableName) at: #OR) add: typeField -> targetClass name.
	targetClass allSubclasses do: [ :sc | ((searchDict at: baseClass tableName) at: #OR) add: typeField -> sc name ].
	[ targetClass ~= baseClass ] whileTrue: 
		[ searchDict 
			at: targetClass tableName
			ifAbsentPut: Dictionary new.
		targetClass := targetClass superclass ].
	^ searchDict! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
createColumnDictionaries
	| baseClass columnDict klass columns infoDict |
	columns := OrderedCollection new.
	baseClass := self currentObject class baseClass.
	infoDict := Dictionary new.
	infoDict 
		at: #tableName
		put: baseClass tableName.
	columnDict := Dictionary new.
	baseClass allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	infoDict 
		at: #columns
		put: columnDict.
	columns add: infoDict.
	klass := self currentObject class.
	[ klass ~= baseClass ] whileTrue: 
		[ infoDict := Dictionary new.
		infoDict 
			at: #tableName
			put: klass tableName.
		columnDict := Dictionary new.
		klass allClassTableColumns associationsDo: 
			[ :assoc | 
			columnDict 
				at: assoc value columnName
				put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
		infoDict 
			at: #columns
			put: columnDict.
		columns add: infoDict.
		klass := klass superclass ].
	^ columns! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
createSpecificTableStructure
	| sampleClass connection lightOidColumn columnDict baseClass |
	sampleClass := self currentObject class.
	baseClass := sampleClass baseClass.
	connection := sampleClass sqSaveConnection.

	"this oid column is lacking the auto increment feature, since this has to be set manually"
	"however we need a foreign key constraint to simplify maintaining  data integrity between the tables"
	lightOidColumn := SqSaveColumnDescription new
		columnName: 'oid';
		sqlType: connection integer;
		canBeNull: false;
		isPrimaryKey: true;
		foreignKey: (SqSaveForeignKeyDescription new
				referencedColumns: #('oid' );
				deleteActions: #(#CASCADE );
				referencedTable: baseClass tableName).

	"create the base class table first, if it does not already exist"
	baseClass tableForClassExists ifFalse: 
		[ connection executeQuery: (connection 
				queryToCreateTableNamed: baseClass tableName
				withColumns: baseClass allClassTableColumns) ].
	(TableCache at: baseClass name) 
		at: baseClass tableName
		put: baseClass allClassTableColumns.

	"the create all other tables in the hierarchy"
	[ sampleClass = baseClass ] whileFalse: 
		[ sampleClass tableForClassExists ifFalse: 
			[ columnDict := sampleClass allClassTableColumns.
			columnDict 
				at: 'oid'
				put: lightOidColumn.
			connection executeQuery: (connection 
					queryToCreateTableNamed: sampleClass tableName
					withColumns: columnDict) ].
		(TableCache at: baseClass name) 
			at: sampleClass tableName
			put: sampleClass allClassTableColumns.
		sampleClass := sampleClass superclass ]! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
deleteObject
	"this is were the beauty of foreign key constraints kicks in - just delete the object in the base table"
	^ self currentObject class sqSaveConnection 
		removeObjectWithId: self currentObject oid
		fromTable: self currentObject class baseClass tableName! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	| connection baseClass columnDict lastOid klass |
	connection := self currentObject class sqSaveConnection.
	baseClass := self currentObject class baseClass.
	columnDict := Dictionary new.
	baseClass allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	connection inTransactionDo: 
		[ lastOid := connection 
			storeColumns: columnDict
			inTable: baseClass tableName
			andReturnOId: true.
		klass := self currentObject class.
		[ klass ~= baseClass ] whileTrue: 
			[ columnDict := Dictionary new.
			klass allClassTableColumns associationsDo: 
				[ :assoc | 
				columnDict 
					at: assoc value columnName
					put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
			columnDict 
				at: 'oid'
				put: lastOid.
			connection 
				storeColumns: columnDict
				inTable: klass tableName.
			klass := klass superclass ] ].
	^ lastOid! !

SqSaveTableStructureHandler subclass: #SqSaveSingleTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
buildSearchFor: instVars withValues: values 
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName |
	descrHandler := self currentObject descriptionHandler.
	targetClass := self currentObject class.
	searchDict := Dictionary new.
	baseClass := targetClass baseClass.
	typeField := targetClass sqSaveConnection class inheritanceTypeField.
	instVars withIndexDo: 
		[ :ivar :index | 
		ivar = 'oid' 
			ifTrue: 
				[ tableName := baseClass tableName.
				columnName := 'oid' ]
			ifFalse: 
				[ descr := descrHandler columnDescriptionFor: ivar.
				tableName := descr tableName.
				columnName := descr columnName ].
		(searchDict 
			at: tableName
			ifAbsentPut: Dictionary new) 
			at: #AND
			ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: columnName -> (values at: index) ].
	(searchDict 
		at: baseClass tableName
		ifAbsentPut: Dictionary new) 
		at: #OR
		ifAbsentPut: Set new.
	((searchDict at: baseClass tableName) at: #OR) add: typeField -> targetClass name.
	targetClass allSubclasses do: [ :sc | ((searchDict at: baseClass tableName) at: #OR) add: typeField -> sc name ].
	^ searchDict! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
createColumnDictionaries
	| columnDict infoDict |
	columnDict := Dictionary new.
	self currentObject class allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	infoDict := Dictionary newFrom: { 
			(#tableName -> self currentObject class tableName).
			(#columns -> columnDict)
		 }.
	^ OrderedCollection with: infoDict! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
createSpecificTableStructure
	| connection columnDictionary sampleClass |
	sampleClass := self currentObject class.
	connection := self currentObject sqSaveConnection.
	columnDictionary := self currentObject allClassTableColumns.
	(TableCache at: sampleClass baseClass name) 
		at: sampleClass tableName
		put: columnDictionary.
	connection executeQuery: (connection 
			queryToCreateTableNamed: sampleClass tableName
			withColumns: columnDictionary)! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
deleteObject
	^ self currentObject sqSaveConnection 
		removeObjectWithId: self currentObject oid
		fromTable: self currentObject class tableName! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	| columnDict connection |
	columnDict := Dictionary new.
	connection := self currentObject sqSaveConnection.
	self currentObject allClassTableColumns associationsDo: 
		[ :assoc | 
		columnDict 
			at: assoc value columnName
			put: (self currentObject escapedValueForInstanceVariable: assoc key) ].
	^ connection 
		storeColumns: columnDict
		inTable: self currentObject tableName
		andReturnOId: true! !

!SqSaveTableStructureHandler class methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:04'!
for: anObject 
	"determine the proper structure handler class"
	| inheritanceMode targetClass |
	inheritanceMode := anObject class descriptionHandler inheritanceModeForClass: anObject class.
	targetClass := 'SqSave' , inheritanceMode capitalized , 'TableStructureHandler'.
	targetClass := Smalltalk 
		at: targetClass asSymbol
		ifAbsent: [ self error: 'Unknown inheritance Mode' ].
	"initialize the table cache (if not already done...)"
	TableCache ifNil: [ TableCache := Dictionary new ].
	"and return a completely new handler"
	^ targetClass new
		currentObject: anObject;
		yourself! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:07'!
buildSearchFor: instVars withValues: values
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/17/2008 16:15'!
createColumnDictionaries
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
createJoinTableFromDescription: reference 
	| referenceColumn ownerColumn columns descr |
	descr := reference at: #description.
	referenceColumn := descr referenceColumn.
	ownerColumn := descr ownerColumn.
	columns := OrderedCollection 
		with: ownerColumn
		with: referenceColumn.
	self currentObject sqSaveConnection 
		createJoinTableNamed: descr joinTableName
		withColumns: columns
		andOrderField: descr maintainOrder.
	self insertJoinTableDescriptionToCache: reference! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/14/2008 11:51'!
createSpecificTableStructure
	^self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:05'!
createTableStructure
	"reinitialize the table cache, since we are recreating the structure"
	TableCache 
		at: self currentObject class name
		put: Dictionary new.
	self createSpecificTableStructure.
	self currentObject indirectlyReferencedObjects do: [ :reference | self createJoinTableFromDescription: reference ]! !

!SqSaveTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:05'!
currentObject
	^ currentObject! !

!SqSaveTableStructureHandler methodsFor: 'accessing' stamp: 'tk 8/25/2008 11:04'!
currentObject: anObject 
	currentObject := anObject! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/12/2008 17:35'!
deleteObject
	^self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:49'!
findChangedColumnsInJoinTable: aDescr ofClass: aClass
	| oldDescription changedColumns descr |
	descr := aDescr at: #description.
	
	oldDescription := ((TableCache at: aClass name) at: descr joinTableName).
	
	changedColumns := Dictionary new.	
	(oldDescription ownerColumn columnName ~= descr ownerColumn columnName) ifTrue: [
		changedColumns at: #renamed put: descr ownerColumn	
	].

	(oldDescription referenceColumn columnName ~= descr referenceColumn columnName) ifTrue: [
		changedColumns at: #renamed put: descr referenceColumn	
	].

	(oldDescription ownerColumn sqlType ~= descr ownerColumn sqlType) ifTrue: [
		changedColumns at: #altered put: descr ownerColumn	
	].

	(oldDescription referenceColumn sqlType ~= descr referenceColumn sqlType) ifTrue: [
		changedColumns at: #altered put: descr referenceColumn	
	].
	
	"finally set up the table cache at the corresponding entry..."
	(TableCache at: aClass name) at: descr joinTableName put: descr.

	^changedColumns


	! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 14:28'!
findChangesInClass: aClass storeIn: changedColumns
	| curColumns oldColumns curCol prevCol |
	curColumns := aClass allClassTableColumns.
	oldColumns := (TableCache at: aClass baseClass name) 
		at: aClass tableName
		ifAbsent: [ Dictionary new ].
	oldColumns associationsDo: [ :assoc | 
		curCol := curColumns at: assoc key.
		prevCol := assoc value.
		"if we can't find the current column for an old one it has been deleted'"
		curCol 
			ifNil: [ (changedColumns at: #deleted) add: prevCol ]
			ifNotNil: [ 
				"if the name's different, add it to changed'"
				curCol columnName ~= prevCol columnName ifTrue: [ 
					(changedColumns at: #renamed) add: (OrderedCollection 
						with: prevCol
						with: curCol)
				].
				"same for sql type"
				(curCol sqlType ~= prevCol sqlType and: [ curCol sqlType isNil not ]) ifTrue: [ (changedColumns at: #altered) add: curCol ] 
			] 
	].
	"and now find the columns that have been added"
	(changedColumns at: #added) addAll: (curColumns associationsSelect: [ :assoc | (oldColumns includesKey: assoc key) not ]) values.
	! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 15:48'!
getChangedColumns

	| baseClass joinChanges descr |
	baseClass := self currentObject class baseClass.
	joinChanges := Dictionary new.
	self currentObject indirectlyReferencedObjects do: 
		[ :reference | 
		descr := reference at: #description.
		((TableCache at: baseClass name) includesKey: descr joinTableName) 
			ifTrue: 
				[ joinChanges valueJoin: (self 
						findChangedColumnsInJoinTable: reference
						ofClass: baseClass) ]
			ifFalse: [ self createJoinTableFromDescription: reference ] ].
	^ joinChanges valueJoin: self getStructureSpecificChangedColumns! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 14:25'!
getStructureSpecificChangedColumns
	| currentClass changedColumns baseClass |
	currentClass := self currentObject class.
	baseClass := currentClass baseClass.
	changedColumns := Dictionary newFrom: { 
			(#renamed -> Set new).
			(#deleted -> Set new).
			(#altered -> Set new).
			(#added -> Set new)
		 }.
	[ currentClass ~= SqSaveBase ] whileTrue: [ 
		self findChangesInClass: currentClass storeIn: changedColumns.
		currentClass := currentClass superclass 
	].
	^ changedColumns! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:12'!
insertCurrentObject
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/25/2008 11:58'!
insertJoinTableDescriptionToCache: reference 
	| descr |
	descr := reference at: #description.
	(TableCache at: self currentObject class baseClass name) 
		at: descr joinTableName
		put: descr! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 18:23'!
insertObject
	| |
	"first store all objects that are directly referenced by the main object - i.e. one-to-one relations"
	self currentObject directlyReferencedObjects do: [ :obj | obj save ].

	"next store the object itself"
	self currentObject oid: (self insertCurrentObject).

	"store all objects the sample object holds within one-to-many associations - they explicitly need the oid"
	self insertOwnedCollections.! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 15:11'!
insertOwnedCollections
	| columnDict connection collectionDescription counter |
	columnDict := Dictionary new.
	connection := self currentObject sqSaveConnection.
	
	self currentObject indirectlyReferencedObjects do: [ :reference | 
		collectionDescription := reference at: #description.
		counter := 1.
		(reference at: #collection) do: [ :obj | 
			obj save.
			columnDict := Dictionary new.
			columnDict 
				at: collectionDescription referenceColumn columnName
				put: obj oid.
			columnDict 
				at: collectionDescription ownerColumn columnName
				put: self currentObject oid.
				collectionDescription maintainOrder ifTrue: [
					columnDict at: connection class collectionOrderField put: counter
				].
				counter := counter + 1.
			connection 
				storeColumns: columnDict
				inTable: collectionDescription joinTableName ]
	].! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
loadProxiedObjectOfVariable: ivarName 
	| descr connection collectionElements |
	descr := self currentObject descriptionHandler columnDescriptionFor: ivarName.
	connection := self currentObject sqSaveConnection.
	collectionElements := connection 
		getCollectionDescribedBy: descr
		forObjectId: self currentObject oid.
	^ descr collectionClass withAll: collectionElements! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 14:59'!
updateObject
	| columnDicts connection |
	"store all directly associated objects right now"
	self currentObject directlyReferencedObjects do: [:obj | obj save].
	
	columnDicts := self createColumnDictionaries.
	connection := self currentObject sqSaveConnection.
	columnDicts do: 
		[ :columnDict | 
		connection inTransactionDo: 
			[ connection 
				updateFields: (columnDict at: #columns)
				ofObjectWithId: self currentObject oid
				inTable: (columnDict at: #tableName) ] ].
		
	self updateOwnedCollections.
	
	! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/28/2008 18:34'!
updateOwnedCollections
	| changes proxy |
	self currentObject indirectlyReferencedObjects do: [:reference | 
		"this object should always be an SqSaveCollectionProxy that 
		knows how the object looked like at the last save"
		proxy := reference at: #collection.
		proxy do: [:collectionObj | collectionObj save].
		changes := proxy getCollectionChanges.
	].
	
	! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 8/26/2008 17:51'!
updateTableStructure
	| structureChanges connection |
	structureChanges := self getChangedColumns.
	connection := self currentObject sqSaveConnection.
	"first rename the columns that need renaming"
	connection renameColumns: (structureChanges at: #renamed).
	"then alter the ones that need to be altered (sql whise)"
	connection alterColumns: (structureChanges at: #altered).
	"delete..."
	connection removeColumns: (structureChanges at: #deleted).
	"add..."
	connection addColumns: (structureChanges at: #added)! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionClass
	^#MANumberDescription! !

!Number methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:10'!
magritteDescriptionDefaultValue
	^'0'! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionStandardValue
	^0! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionClass
	^#MADateDescription! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionDefaultValue
	^'Date today'! !

!Dictionary methodsFor: '*tksave' stamp: 'tk 8/15/2008 14:55'!
valueJoin: anotherDictionary
	"really joins two dictionaries with collections as values"
	| ownValue mergeValue |
	anotherDictionary associationsDo: [ :assoc |
		(self includesKey: assoc key) ifTrue: [
			ownValue := (self at: assoc key) isCollection ifTrue:[
				self at: assoc key
			] ifFalse: [
				OrderedCollection with: (self at: assoc key)
			].
			mergeValue := (assoc value) isCollection ifTrue:[
				assoc value
			] ifFalse: [
				OrderedCollection with: (assoc value).
			].
			self at: assoc key put: (ownValue union: mergeValue).
		] ifFalse: [
			self at: assoc key put: assoc value
		]
	].
	^self! !
